
subroutine saturation(sat, TABS, r_dry, m_sol, a_sig, r_krit, m_ggw, iter)

  implicit none
  double precision, intent (in)  :: sat, TABS, r_dry, m_sol, a_sig, r_krit
  double precision, intent (out) :: m_ggw
  integer, intent(out) :: iter
  
  double precision :: r_wet, molality, r_min, s_ggw, sat_log
  integer :: i
  
  ! estimation of the boundary
  r_min=r_krit
  
  ! max iterations
  iter = 500
  
  !
  sat_log = log(sat+1.0d0)
  
  do i=1,iter

    r_min = r_min*0.9D0
    r_wet = (r_dry**3 + r_min**3)**(1.d0/3.d0)
    m_ggw = 4188.79D0*r_min**3
    molality = m_sol / (0.13213D0*m_ggw)
    s_ggw = 2.D0 * (a_sig+6.7D-4*molality) / (461500.0D0*TABS*r_wet) - molality*0.054D0

    if(s_ggw < sat_log) then
       ! equilibrium
       iter = i
       exit
    endif

  end do

end subroutine saturation



program test

  implicit none
  double precision :: sat,TABS,r_dry,m_sol,a_sig,r_krit,m_ggw
  integer :: iter

  ! reading parameters from file prevents compiler from optimizing everything away
  read(345,*) sat
  read(345,*) TABS
  read(345,*) r_dry
  read(345,*) m_sol
  read(345,*) a_sig
  read(345,*) r_krit
  
  call saturation(sat, TABS, r_dry, m_sol, a_sig, r_krit, m_ggw, iter)
  
  write(*,*) 'm_ggw = ',m_ggw
  write(*,*) 'iter  = ',iter

end program test
