#include <stdio.h>
#include <stdlib.h>
#include "../papi/papi_wrap.h"
#define N 10000
#include <math.h>
   
/* Welche Genauigkeit */
#define PRECISION double

typedef struct { 
	PRECISION			valid;
	PRECISION	x, y, z;
} __attribute__((packed)) R3 ;


#define x(i) x[i]
#define y(i) y[i]
#define z(i) z[i]

PRECISION do_flops(PRECISION x[],PRECISION  y[],PRECISION  z[])
{	
	int i;
	PRECISION s=0;
	for (i=0; i< N; i++) {
		s = s + x(i)*x(i) + y(i)*y(i) + z(i)*z(i);
	}
	return sqrt(s);
}
/*

#define x(i) data[i].x
#define y(i) data[i].y
#define z(i) data[i].z

PRECISION do_flops(R3 data[])
{	
	int i;
	PRECISION s=0;
	for (i=0; i< N; i++) {
		s += x(i)*x(i) + y(i)*y(i) + z(i)*z(i);
	}
	return sqrt(s);
}
*/
int main()
{
	R3* data;
	PRECISION x[N], y[N], z[N];
	
	
	int nCount=4;
	long long v1[nCount], v0[nCount];
	char *sList[nCount+1];
	int i;
	
	data = (R3*) malloc(N * sizeof(R3));
	
	double t0,t1;
	
	sList[0]="PAPI_TOT_CYC";
	sList[1]="PAPI_FP_INS";
	sList[2]="PAPI_VEC_INS";
	sList[3]="PAPI_L1_ICA";
	sList[3]=NULL;
	
	
	initPAPI(sList);

 	
	for (i=0; i< N; i++) {
		x(i) = i+1;
		y(i) = i+1;	
		z(i) = i;	
	}
		
	printf("Start work \n");
	t0 = PAPI_get_real_usec();
	readPAPIcounters(v0);
	
/*	printf("Sizeof R3 : %d\n", sizeof(R3));
	if (do_flops(data)<0) */
	if (do_flops(x,y,z)<0)
		printf("<0");
	
	readPAPIcounters(v1);

	t1 = PAPI_get_real_usec();
	printf("%20s\t    %3.6f s\t%f GFLOPS\n","time", 
		(t1-t0)/1000000 ,((long)6*N)/(t1-t0)/1000); 
	i=0;
	do {
		printf("%20s\t%12lld\t%f G/s\n", sList[i],v1[i]-v0[i], (v1[i]-v0[i])/(t1-t0)/1000);
		i++;
	} while (sList[i]!=NULL);
	
	stopPAPI();


}



