#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include "../papi/papi_wrap.h"
 
#define N 1000

/* Welche Genauigkeit */
#define DOUBLE

#ifdef SINGLE
	#define PRECISION float
#else
	#define PRECISION double
#endif


PRECISION do_flops(PRECISION a[],PRECISION  b[],PRECISION  c[])
{
	int i,j,k;double s;
	for (i=0; i<N; i++) {
		for (j=0; j<N; j++) {
			for (k=0; k<N; k++) {
				c[i*N+j]+= a[i*N+k] * b[k*N+j];
			}
		}
	}
	return 1.1;
}

int main()
{
	int nCount=8;
	int i,j;
	char *sList[nCount];
	sList[0]="PAPI_FP_INS";
	sList[1]="PAPI_VEC_INS";
	sList[2]="PAPI_L2_DCM";
	sList[3]=NULL;
	
	PRECISION *a, *b, *c;
	char *mem;
	double t0,t1;
	long long v1[nCount], v0[nCount];
	
	
 	a=(PRECISION*) (malloc(N *N* sizeof(PRECISION)) );
 	b=(PRECISION*) (malloc(N *N* sizeof(PRECISION)) );
 	c=(PRECISION*) (malloc(N *N* sizeof(PRECISION)) );
	
	for (i=0; i< N*N; i++) 
	{
		a[i] = i+1;
		b[i] = i+1;	
	}
	
	initPAPI(sList);
	t0 = PAPI_get_real_usec();
	
	readPAPIcounters(v0);
	
	if (do_flops(a,b,c)<0)
		printf("<0");
	readPAPIcounters(v1);

	t1 = PAPI_get_real_usec();
	printf("%20s\t    %3.6f s\t%f GFLOPS\n","time", (t1-t0)/1000000 ,((long)2*N*N*N)/(t1-t0)/1000); 
	i=0;
	do {
		printf("%20s\t%12lld\t%f G/s\n", sList[i],v1[i]-v0[i], (v1[i]-v0[i])/(t1-t0)/1000);
		i++;
	} while (sList[i]!=NULL);
	
   stopPAPI();


}



