#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "../papi/papi_wrap.h"
#include "mkl_cblas.h"
#include <xmmintrin.h>
#define N 1000
 
/* Welche Genauigkeit */
#define DOUBLE

#ifdef SINGLE
	#define PRECISION float
#else
	#define PRECISION double
#endif

PRECISION do_flops(PRECISION a[],PRECISION  b[],PRECISION  c[])
{	
     CBLAS_ORDER     order= CblasRowMajor;
      CBLAS_TRANSPOSE transA= CblasNoTrans, transB= CblasNoTrans;
#ifdef SINGLE
	cblas_sgemm(CblasRowMajor, CblasNoTrans, CblasNoTrans, N, N, N, 1.0,
                  a, N, b, N, 1.0, c, N);
#else
	cblas_dgemm(CblasRowMajor, CblasNoTrans, CblasNoTrans, N, N, N, 1.0,
                  a, N, b, N, 1.0, c, N);
#endif

	return 1.1;
}


int main()
{
	int nCount=8;
	int i,j;
	char *sList[nCount];
	sList[0]="PAPI_L1_DCM";
	sList[1]="PAPI_L1_DCH";
	sList[2]="PAPI_L2_D";
	sList[3]="PAPI_L2_DCH";
	sList[4]=NULL;
	
	PRECISION *a, *b, *c;
	char *mem;
	double t0,t1;
	long long v1[nCount], v0[nCount];
	
	
 	a=(PRECISION*) (malloc(N *N* sizeof(PRECISION)+8) );
 	b=(PRECISION*) (malloc(N *N* sizeof(PRECISION)+8) );
 	c=(PRECISION*) (malloc(N *N* sizeof(PRECISION)+8) );
	
	for (i=0; i< N*N; i++) 
	{
		a[i] = i+1;
		b[i] = i+1;	
	}
	
	initPAPI(sList);
	t0 = PAPI_get_real_usec();
	
	readPAPIcounters(v0);
	
	if (do_flops(a,b,c)<0)
		printf("<0");
	readPAPIcounters(v1);

	t1 = PAPI_get_real_usec();
	printf("%20s\t    %3.6f s\t%f GFLOPS\n","time", (t1-t0)/1000000 ,((long)2*N*N*N)/(t1-t0)/1000); 
	i=0;
	do {
		printf("%20s\t%12lld\t%f G/s\n", sList[i],v1[i]-v0[i], (v1[i]-v0[i])/(t1-t0)/1000);
		i++;
	} while (sList[i]!=NULL);
	
   stopPAPI();


}







