#include <papi.h>
#include <stdio.h>
#include <stdlib.h>

#include "papi_wrap.h"

int iEventSet=PAPI_NULL;

void initPAPI(char* sList[]) {
	int retval=-123, c;
	PAPI_event_info_t info;
	
	if ( PAPI_VER_CURRENT != (retval=PAPI_library_init(PAPI_VER_CURRENT))) { 
		fprintf(stderr,"PAPI library init error! retval=%d\ncontinue without PAPI...\n",retval);
		exit(-1);
	}
	if (PAPI_create_eventset(&iEventSet) != PAPI_OK) {
		fprintf(stderr,"PAPI library error %d.\n",retval);
		exit(-2);
	}	

	while (*sList != 0) {

		PAPI_event_name_to_code(*sList, &c);
		
		if (PAPI_get_event_info(c, &info) != PAPI_OK) {
			if (PAPI_enum_event(&c, 0) != PAPI_OK) {
				fprintf(stderr,"PAPI error enum");
				exit(-4);
			}
			printf("%s->%s \n", info.symbol, info.long_descr);
		}
		if ((retval=PAPI_add_event(iEventSet, c) )!= PAPI_OK){
			fprintf(stderr,"PAPI_add_event error %d -- %d.\n", iEventSet,retval);
			exit(-4);
		}
		sList++;
	}
	 
	if ( (retval=PAPI_start(iEventSet)) != PAPI_OK) {
		fprintf(stderr, "PAPI start error %d.\n",retval);
		exit(-1);
	}
}

void stopPAPI(void) {
	int c;
    if ((c=PAPI_stop(iEventSet, NULL)) != PAPI_OK){
		fprintf(stderr, "PAPI stop error %d.\n",c );
		exit(-1);
	}
}
